pub mod udp;
pub mod decoder;

use crate::models::DNSQuery;
use crate::models::DNSResponse;
use crate::proto::udp::DNSParseError;

pub use crate::proto::udp::UdpCoder;

pub trait Coder {
    fn decode(datagram: &[u8]) -> Result<DNSQuery, DNSParseError>;
    fn encode(respone: DNSResponse) -> Result<Vec<u8>, DNSParseError>;
}